
#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Red
#property indicator_color3 White
//**************************************************************************/
extern int TimeFrame=240;
extern int MAPeriod=8;
extern int ma_method=MODE_SMA;
extern bool ShowRawData = true;



double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
int applied_price=PRICE_CLOSE;
int ma_shift=0;


double UpBuffer[];
double DnBuffer[];
double RawBuffer[];
double SmoothBuffer[];
   int i, limit;
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  { 
   //---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);   
 
//----
   return(0);
 }
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
  {
  Comment("Bid: ",Bid);
      Draw();
      

   return(0);
  }
//+------------------------------------------------------------------+


void Draw()
{
//-------------------

      limit=Bars;
      ArrayResize(RawBuffer, limit + 100);
      ArrayResize(SmoothBuffer, limit + 100);
      ArraySetAsSeries(RawBuffer,true);
      ArraySetAsSeries(SmoothBuffer,true);
      //
      ArrayInitialize(RawBuffer, 0);
      ArrayInitialize(SmoothBuffer, 0);

      i= limit;      
      while(i >= 0)
         {              
         int Bar_Shift=iBarShift(NULL,TimeFrame,Time[i],false);
         RawBuffer[i]=iMA(NULL,TimeFrame,MAPeriod,0,ma_method,2,Bar_Shift) ; 
         if(ShowRawData) ExtMapBuffer3[i]= RawBuffer[i];          
         i--;
         }
     
      i= limit;
      while(i >= 0)
         {         
          SmoothBuffer[i] = iMAOnArray(RawBuffer,0,(TimeFrame/Period() ),0,0,i);      
          if(SmoothBuffer[i] > SmoothBuffer[i+1] ) ExtMapBuffer1[i]=SmoothBuffer[i];
          if(SmoothBuffer[i] < SmoothBuffer[i+1] ) ExtMapBuffer2[i]=SmoothBuffer[i];
         i--;
         }         

//-------------------
return(0);
}